// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	errortest: check if the error handling works
//
//	UL, Wed Oct 13 19:01:18 MET DST 1999
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/selectlib/test/errortest.cc,v 1.6 2002/12/17 17:48:12 jbakker Exp $
//
#include <iostream>
#include <cassert>
#include "SelectError.h"
#include "Evaluator.h"

using namespace SelectError;

#define NUM_OF(a)	(sizeof(a)/sizeof(a[0]))
int main()
{
	//	switch on exception handling
	selectErrorHandler.exceptions(true);

	const char *expr[] = { "1==1", "p==", "" };
	bool results[] = { true, false, true };

	for (unsigned n=0; n<NUM_OF(expr); ++n) {
		try {
			Evaluator ev(expr[n]);
			assert(results[n]);
		} catch (SelectException e) {
			assert(!results[n]);
			std::cerr<<e.text()<<std::endl;
		}

		assert(Evaluator::isValidExpression(expr[n]) == results[n]);
	}

	return 0;
}



